/**
 * Student: Pandia Gheorghe
 * Grupa:   331
 * Seria:   CC
 * -------------------------
 * Proiect PM 2010 - Damesah
 */

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#define BLINK_TIME	10

#define RED 	1
#define GREEN	2
#define YELLOW	3

#define WONDERING	0
#define MOVING		1

char gMatrix[8][8];	// Matricea de led-uri

char gSelectedX;	// Linia piesei selectate
char gSelectedY;	// Coloana piesei selectate

char gMovedX;		// Linia ultimei pozitii a piesei
char gMovedY;		// Coloana ultimei pozitii a piesei

char gStage;		// Stagiul in care se afla jucatorul curent (alege piesa, muta, paseaza stafeta)
char gMutari;		// Numarul de mutari disponibile unei anumite piese

char gPlayer;		// Jucatorul care este la mutare

char gOnOff;		// Folosita in clipire
int gCounter;		// Folosit pentru clipire

/**
 * FUNCTION: TOGGLE
 * Schimba valoarea lui gOnOff intre On si Off :p
 *
 * @param
 * @return
 */
void toggle()
{
	if( gOnOff )
		gOnOff = 0;
	else
		gOnOff = 1;
}

/**
 * FUNCTION: SHOWMATRIX
 * Desenare matrice pe leduri si clipire selectie
 *
 * @param
 * @return
 */
void showMatrix()
{
	int i, j, k;

	// Clipire selectie
	gCounter++;
	if( gCounter >= BLINK_TIME )
	{
		toggle();
		gCounter = 0;
	}

	// Afisare matrice
	for( i=0; i<8; i++ )
	{
		for( j=0; j<8; j++ )
		{
			PORTA = 0; //red
			PORTB = 0; //green
			PORTD = 0; //col
			if( ( gOnOff ) || ( i != gSelectedX ) || ( j != gSelectedY ) )
				switch( gMatrix[i][j] )
				{
					case 0:
						PORTA = 0;
						PORTB = 0;
						PORTD = 0;
						break;
					case 1: 
						if( j > 0 ) PORTA = 1<<j;
							else PORTA = 1;
						PORTB = 0;
						if( i > 0 ) PORTD = 1<<i;
							else PORTD = 1;
						break;
					case 2: 
						if( j > 0 ) PORTB = 1<<j; 
							else PORTB = 1;
						PORTA = 0;
						if( i > 0 ) PORTD = 1<<i;
							else PORTD = 1;
						break;
					case 3: 
						if( j > 0 ) 
						{
							PORTB = 1<<j; 
							PORTA = 1<<j;
						}
							else 
							{
								PORTB = 1;
								PORTA = 1;
							}
						if( i > 0 ) PORTD = 1<<i;
							else PORTD = 1;
						break;
				}

			// Simulare delay la microsecunda
			k = 0;
			for( k=0; k<450; k++ )
				_delay_ms( 0 );
		}
	}

}

/**
 * FUNCTION: INVESTIGATEREDJUMP
 * Investigheaza daca se poate sari mai departe decat s-a ajuns deja
 *
 * @param char x - Linia pozitiei investigate
 * @param char y - Coloana pozitiei investigate
 * @return
 */
void investigateRedJump(char x, char y)
{
	// Spre stanga
	if( ( x < 7 ) && ( y > 0 ) )
		if( gMatrix[x+1][y-1] != 0 )
			if( ( x + 1 < 7 ) && ( y - 1 > 0 ) )
				if( gMatrix[x+2][y-2] == 0 )
				{
					gMutari++;
					gMatrix[x+2][y-2] = 3;
					investigateRedJump( x+2, y-2 );
				}

	// Spre dreapta
	if( ( x < 7 ) && ( y < 7 ) )
		if( gMatrix[x+1][y+1] != 0 )
			if( ( x + 1 < 7 ) && ( y + 1 < 7 ) )
				if( gMatrix[x+2][y+2] == 0 )
				{
					gMutari++;
					gMatrix[x+2][y+2] = 3;
					investigateRedJump( x+2, y+2 );
				}
}


/**
 * FUNCTION: INVESTIGATERED
 * Investigheaza mutarile posibile pentru jucatorul rosu
 *
 * @param char x - Linia pozitiei investigate
 * @param char y - Coloana pozitiei investigate
 * @return
 */
void investigateRed(char x, char y)
{
	// Spre stanga
	if( ( x < 7 ) && ( y > 0 ) )
		if( gMatrix[x+1][y-1] == 0 )
		{
			gMutari++;
			gMatrix[x+1][y-1] = 3;
		}
		else
		if( ( x + 1 < 7 ) && ( y - 1 > 0 ) )
			if( gMatrix[x+2][y-2] == 0 )
			{
				gMutari++;
				gMatrix[x+2][y-2] = 3;
				investigateRedJump( x+2, y-2 );
			}

	// Spre dreapta
	if( ( x < 7 ) && ( y < 7 ) )
		if( gMatrix[x+1][y+1] == 0 )
		{
			gMutari++;
			gMatrix[x+1][y+1] = 3;
		}
		else
		if( ( x + 1 < 7 ) && ( y + 1 < 7 ) )
			if( gMatrix[x+2][y+2] == 0 )
			{
				gMutari++;
				gMatrix[x+2][y+2] = 3;
				investigateRedJump( x+2, y+2 );
			}

}

/**
 * FUNCTION: INVESTIGATEGREENJUMP
 * Investigheaza daca se poate sari mai departe decat s-a ajuns deja
 *
 * @param char x - Linia pozitiei investigate
 * @param char y - Coloana pozitiei investigate
 * @return
 */
void investigateGreenJump(char x, char y)
{
	// Spre dreapta
	if( ( x > 0 ) && ( y > 0 ) )
		if( gMatrix[x-1][y-1] != 0 )
			if( ( x - 1 > 0 ) && ( y - 1 > 0 ) )
				if( gMatrix[x-2][y-2] == 0 )
				{
					gMutari++;
					gMatrix[x-2][y-2] = 3;
					investigateGreenJump( x-2, y-2 );
				}

	// Spre stanga
	if( ( x > 0 ) && ( y < 7 ) )
		if( gMatrix[x-1][y+1] != 0 )
			if( ( x - 1 > 0 ) && ( y + 1 < 7 ) )
				if( gMatrix[x-2][y+2] == 0 )
				{
					gMutari++;
					gMatrix[x-2][y+2] = 3;
					investigateGreenJump( x-2, y+2 );
				}
}


/**
 * FUNCTION: INVESTIGATEGREEN
 * Investigheaza mutarile posibile pentru jucatorul verde
 *
 * @param char x - Linia pozitiei investigate
 * @param char y - Coloana pozitiei investigate
 * @return
 */
void investigateGreen(char x, char y)
{
	// Spre dreapta
	if( ( x > 0 ) && ( y > 0 ) )
		if( gMatrix[x-1][y-1] == 0 )
		{
			gMutari++;
			gMatrix[x-1][y-1] = 3;
		}
		else
		if( ( x - 1 > 0 ) && ( y - 1 > 0 ) )
			if( gMatrix[x-2][y-2] == 0 )
			{
				gMutari++;
				gMatrix[x-2][y-2] = 3;
				investigateGreenJump( x-2, y-2 );
			}

	// Spre stanga
	if( ( x > 0 ) && ( y < 7 ) )
		if( gMatrix[x-1][y+1] == 0 )
		{
			gMutari++;
			gMatrix[x-1][y+1] = 3;
		}
		else
		if( ( x - 1 > 0 ) && ( y + 1 < 7 ) )
			if( gMatrix[x-2][y+2] == 0 )
			{
				gMutari++;
				gMatrix[x-2][y+2] = 3;
				investigateGreenJump( x-2, y+2 );
			}

}

/**
 * FUNCTION: MAIN
 * Initializations and Main Loop go here
 * 
 * @param
 * @return 0 - success, other - insuccess
 */
int main()
{
	int i, j;
	char followColor;	// Culoarea pe care ne putem deplasa


	// Init Stuff

	// Initializare matrice
	for( i=0; i<8; i++ )
		for( j=0; j<8; j++ )
			gMatrix[i][j] = 0;
			
	for( i=0; i<3; i++ )
		for( j=0; j<8; j++ )
			if( j % 2 == i % 2 )
				gMatrix[i][j] = 1;

	for( i=5; i<8; i++ )
		for( j=0; j<8; j++ )
			if( j % 2 == i % 2 )
				gMatrix[i][j] = 2;

	// Initializare globale
	gSelectedX = 0;
	gSelectedY = 0;
	gPlayer = RED;
	gStage = WONDERING;
	followColor = RED;
	gMutari = 0;
	gOnOff = 0;


	// Setam toti pinii porturilor A, B si D ca pini de iesire
	DDRA = 0xFF;
	DDRB = 0xFF;
	DDRD = 0xFF;

	// Setam pinii portului C ca pini de intrare
	DDRC = 0x00;

	// Initializam butoanele
	PORTC |= (1<<PC7);	// Sus
	PORTC |= (1<<PC6);	// Jos
	PORTC |= (1<<PC5);	// Stanga
	PORTC |= (1<<PC4);	// Dreapta
	PORTC |= (1<<PC3);	// Enter
	PORTC |= (1<<PC2);	// Back


	gCounter = 0;

	// Main loop
	while(1){

		// Sus
		if( (!(PINC&(1<<PC7))) )
		{
			while( (!(PINC&(1<<PC7))) )
				showMatrix();

			if( gPlayer == RED )
			{
				for( i=gSelectedX+1; i<8; i++ )
					if( gMatrix[i][gSelectedY] == followColor )
					{
						gSelectedX = i;
						break;
					}
				while( i == 8 )
				{
					gSelectedY--;
					if( gSelectedY < 0 )
						gSelectedY = 7;
					for( i=0; i<8; i++ )
						if( gMatrix[i][gSelectedY] == followColor )
						{
							gSelectedX = i;
							break;
						}
				}
			}
			else
			{
				for( i=gSelectedX-1; i>=0; i-- )
					if( gMatrix[i][gSelectedY] == followColor )
					{
						gSelectedX = i;
						break;
					}
				while( i == -1 )
				{
					gSelectedY++;
					if( gSelectedY > 7 )
						gSelectedY = 0;
					for( i=7; i>=0; i-- )
						if( gMatrix[i][gSelectedY] == followColor )
						{
							gSelectedX = i;
							break;
						}
				}
			}
		}

		// Jos
		if( (!(PINC&(1<<PC6))) )
		{
			while( (!(PINC&(1<<PC6))) )
				showMatrix();

			if( gPlayer == RED )
			{
				for( i=gSelectedX-1; i>=0; i-- )
					if( gMatrix[i][gSelectedY] == followColor )
					{
						gSelectedX = i;
						break;
					}
				while( i == -1 )
				{
					gSelectedY++;
					if( gSelectedY > 7 )
						gSelectedY = 0;
					for( i=7; i>=0; i-- )
						if( gMatrix[i][gSelectedY] == followColor )
						{
							gSelectedX = i;
							break;
						}
				}
			}
			else
			{
				for( i=gSelectedX+1; i<8; i++ )
					if( gMatrix[i][gSelectedY] == followColor )
					{
						gSelectedX = i;
						break;
					}
				while( i == 8 )
				{
					gSelectedY--;
					if( gSelectedY < 0 )
						gSelectedY = 7;
					for( i=0; i<8; i++ )
						if( gMatrix[i][gSelectedY] == followColor )
						{
							gSelectedX = i;
							break;
						}
				}
			}
		}

		// Stanga
		if( (!(PINC&(1<<PC5))) )
		{
			while( (!(PINC&(1<<PC5))) )
				showMatrix();

			if( gPlayer == RED )
			{
				for( j=gSelectedY-1; j>=0; j-- )
					if( gMatrix[gSelectedX][j] == followColor )
					{
						gSelectedY = j;
						break;
					}
				while( j == -1 )
				{
					gSelectedX++;
					if( gSelectedX > 7 )
						gSelectedX = 0;
					for( j=7; j>=0; j-- )
						if( gMatrix[gSelectedX][j] == followColor )
						{
							gSelectedY = j;
							break;
						}
				}
			}
			else
			{
				for( j=gSelectedY+1; j<8; j++ )
					if( gMatrix[gSelectedX][j] == followColor )
					{
						gSelectedY = j;
						break;
					}
				while( j == 8 )
				{
					gSelectedX--;
					if( gSelectedX < 0 )
						gSelectedX = 7;
					for( j=0; j<8; j++ )
						if( gMatrix[gSelectedX][j] == followColor )
						{
							gSelectedY = j;
							break;
						}
				}
			}
		}

		// Dreapta
		if( (!(PINC&(1<<PC4))) )
		{
			while( (!(PINC&(1<<PC4))) )
				showMatrix();

			if( gPlayer == RED )
			{
				for( j=gSelectedY+1; j<8; j++ )
					if( gMatrix[gSelectedX][j] == followColor )
					{
						gSelectedY = j;
						break;
					}
				while( j == 8 )
				{
					gSelectedX--;
					if( gSelectedX < 0 )
						gSelectedX = 7;
					for( j=0; j<8; j++ )
						if( gMatrix[gSelectedX][j] == followColor )
						{
							gSelectedY = j;
							break;
						}
				}
			}
			else
			{
				for( j=gSelectedY-1; j>=0; j-- )
					if( gMatrix[gSelectedX][j] == followColor )
					{
						gSelectedY = j;
						break;
					}
				while( j == -1 )
				{
					gSelectedX++;
					if( gSelectedX > 7 )
						gSelectedX = 0;
					for( j=7; j>=0; j-- )
						if( gMatrix[gSelectedX][j] == followColor )
						{
							gSelectedY = j;
							break;
						}
				}
			}
		}

		// Enter
		if( (!(PINC&(1<<PC3))) )
		{
			while( (!(PINC&(1<<PC3))) )
				showMatrix();

			if( gPlayer == RED )
			{
				if( gStage == WONDERING )
				{
					investigateRed( gSelectedX, gSelectedY );
					if( gMutari > 0 )
					{
						gStage = MOVING;
						gMovedX = gSelectedX;
						gMovedY = gSelectedY;
						gMatrix[gMovedX][gMovedY] = 0;
						followColor = YELLOW;
						for( i=gSelectedX+1; i<8; i++ )
							if( gMatrix[i][gSelectedY] == followColor )
							{
								gSelectedX = i;
								break;
							}
						while( i == 8 )
						{
							gSelectedY--;
							if( gSelectedY < 0 )
								gSelectedY = 7;
							for( i=0; i<8; i++ )
								if( gMatrix[i][gSelectedY] == followColor )
								{
									gSelectedX = i;
									break;
								}
						}
					}
				}
				else
				{
					gPlayer = GREEN;
					gMutari  = 0;
					followColor = GREEN;
					gStage = WONDERING;
					gMatrix[gSelectedX][gSelectedY] = RED;
					for( i=0; i<8; i++ )
						for( j=0; j<8; j++ )
							if( gMatrix[i][j] == YELLOW )
								gMatrix[i][j] = 0;
					for( i=gSelectedX+1; i<8; i++ )
						if( gMatrix[i][gSelectedY] == followColor )
						{
							gSelectedX = i;
							break;
						}
					while( i == 8 )
					{
						gSelectedY--;
						if( gSelectedY < 0 )
							gSelectedY = 7;
						for( i=0; i<8; i++ )
							if( gMatrix[i][gSelectedY] == followColor )
							{
								gSelectedX = i;
								break;
							}
					}
				}
			}
			else
			{
				if( gStage == WONDERING )
				{
					investigateGreen( gSelectedX, gSelectedY );
					if( gMutari > 0 )
					{
						gStage = MOVING;
						gMovedX = gSelectedX;
						gMovedY = gSelectedY;
						gMatrix[gMovedX][gMovedY] = 0;
						followColor = YELLOW;
						for( i=gSelectedX+1; i<8; i++ )
							if( gMatrix[i][gSelectedY] == followColor )
							{
								gSelectedX = i;
								break;
							}
						while( i == 8 )
						{
							gSelectedY--;
							if( gSelectedY < 0 )
								gSelectedY = 7;
							for( i=0; i<8; i++ )
								if( gMatrix[i][gSelectedY] == followColor )
								{
									gSelectedX = i;
									break;
								}
						}
					}
				}
				else
				{
					gPlayer = RED;
					gMutari  = 0;
					followColor = RED;
					gStage = WONDERING;
					gMatrix[gSelectedX][gSelectedY] = GREEN;
					for( i=0; i<8; i++ )
						for( j=0; j<8; j++ )
							if( gMatrix[i][j] == YELLOW )
								gMatrix[i][j] = 0;
					for( i=gSelectedX-1; i>=0; i-- )
						if( gMatrix[i][gSelectedY] == followColor )
						{
							gSelectedX = i;
							break;
						}
					while( i == -1 )
					{
						gSelectedY++;
						if( gSelectedY > 7 )
							gSelectedY = 0;
						for( i=7; i>=0; i-- )
							if( gMatrix[i][gSelectedY] == followColor )
							{
								gSelectedX = i;
								break;
							}
					}
				}
			}
		}

		// Back
		if( (!(PINC&(1<<PC2))) )
		{
			while( (!(PINC&(1<<PC2))) )
				showMatrix();

			if( gStage == MOVING )
			{
				for( i=0; i<8; i++ )
					for( j=0; j<8; j++ )
						if( gMatrix[i][j] == YELLOW )
							gMatrix[i][j] = 0;
				gSelectedX = gMovedX;
				gSelectedY = gMovedY;
				gStage = WONDERING;
				gMutari  = 0;
				if( gPlayer == RED )
				{
					gMatrix[gSelectedX][gSelectedY] = RED;
					followColor = RED;
				}
				else
				{
					gMatrix[gSelectedX][gSelectedY] = GREEN;
					followColor = GREEN;
				}
			}
		}

		showMatrix();


	}
	return 0;
}
